Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h	(revision 111)
@@ -136,13 +136,27 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
-    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-  private   : std::list<decod_queue_entry_t*>* reg_QUEUE                  ;
-  private   : uint32_t                       * reg_NB_INST                ;//[nb_context]
-  private   : uint32_t                         reg_LAST_SLOT              ;
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+    // implementation : common
+  private   : std::list<decod_queue_entry_t*> * reg_QUEUE                  ;
+  private   : uint32_t                        * reg_NB_INST                ;//[nb_context]
+    // implementation : one_fifo only
+  private   : uint32_t                          reg_LAST_SLOT              ;
+    // implementation : multi_fifo only
+  private   : uint32_t                          reg_NUM_BANK_HEAD          ;
+  private   : uint32_t                          reg_NUM_BANK_TAIL          ;
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // implementation : common
   private   : Tcontrol_t                     * internal_DECOD_IN_ACK      ;//[nb_inst_decod]
   private   : Tcontrol_t                     * internal_DECOD_OUT_VAL     ;//[nb_inst_decod]
   private   : Tcontrol_t                     * internal_DECOD_OUT_ACK     ;//[nb_inst_decod]
+    // implementation : one_fifo only
+    // implementation : multi_fifo only
+
+    // function pointer
+  public    : void (morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::*function_transition        ) (void);
+  public    : void (morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::*function_genMoore          ) (void);
+  public    : void (morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::*function_genMealy_decod_out) (void);
 #endif
 
@@ -177,7 +191,15 @@
 					       
 #ifdef SYSTEMC				       
-  public  : void        transition                (void);
-  public  : void        genMoore                  (void);
-  public  : void        genMealy_decod_out        (void);
+  public  : void        transition                             (void);
+  public  : void        genMoore                               (void);
+  public  : void        genMealy_decod_out                     (void);
+
+  public  : void        function_one_fifo_transition           (void);
+  public  : void        function_one_fifo_genMoore             (void);
+  public  : void        function_one_fifo_genMealy_decod_out   (void);
+
+  public  : void        function_multi_fifo_transition         (void);
+  public  : void        function_multi_fifo_genMoore           (void);
+  public  : void        function_multi_fifo_genMealy_decod_out (void);
 #endif					       
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Parameters.h	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Parameters.h	(revision 111)
@@ -11,4 +11,5 @@
 #include "Common/include/Debug.h"
 #include "Behavioural/include/Parameters.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h"
 
 namespace morpheo {
@@ -24,18 +25,22 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : uint32_t            _nb_context             ;
-  public : uint32_t            _nb_inst_decod          ;
-  public : uint32_t            _size_queue             ;
-//public : uint32_t            _size_general_data      ;
-  public : uint32_t          * _nb_branch_speculated   ; //[nb_context]
-  public : uint32_t            _nb_instruction_in_queue;
+  public : uint32_t              _nb_context             ;
+  public : uint32_t              _nb_inst_decod          ;
+  public : uint32_t              _size_queue             ;
+  public : Tdecod_queue_scheme_t _queue_scheme           ;
+//public : uint32_t              _size_general_data      ;
+  public : uint32_t            * _nb_branch_speculated   ; //[nb_context]
+  public : uint32_t              _nb_instruction_in_queue;
+    
+  public : uint32_t              _nb_bank;
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t   nb_context          ,
-			uint32_t   nb_inst_decod       ,
-			uint32_t   size_queue          ,
-			uint32_t   size_general_data   ,
-			uint32_t * nb_branch_speculated,
-                        bool       is_toplevel=false   );
+  public : Parameters  (uint32_t              nb_context          ,
+			uint32_t              nb_inst_decod       ,
+			uint32_t              size_queue          ,
+                        Tdecod_queue_scheme_t queue_scheme        ,
+			uint32_t              size_general_data   ,
+			uint32_t            * nb_branch_speculated,
+                        bool                  is_toplevel=false   );
 //   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h	(revision 111)
@@ -18,4 +18,10 @@
 namespace decod_unit {
 namespace decod_queue {
+
+  typedef enum 
+    {
+       DECOD_QUEUE_SCHEME_ONE_FIFO   // One fifo with a instruction bundle per slot (   internal fragmentation)
+      ,DECOD_QUEUE_SCHEME_MULTI_FIFO // One fifo per instruction. Rename in order   (no internal fragmentation)
+    } Tdecod_queue_scheme_t;
 
   class decod_queue_entry_t
@@ -117,6 +123,29 @@
 }; // end namespace multi_front_end
 }; // end namespace core
+}; // end namespace behavioural
 
-}; // end namespace behavioural
+  template<> inline std::string toString<morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Tdecod_queue_scheme_t>(const morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Tdecod_queue_scheme_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::DECOD_QUEUE_SCHEME_ONE_FIFO   : return "one_fifo"  ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::DECOD_QUEUE_SCHEME_MULTI_FIFO : return "multi_fifo"; break;
+      default : return ""; break;
+      }
+  };
+
+  template<> inline morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Tdecod_queue_scheme_t fromString<morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Tdecod_queue_scheme_t>(const std::string& x)
+  {
+    if ( (x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::DECOD_QUEUE_SCHEME_ONE_FIFO  ))) == 0) or
+         (x.compare("one_fifo")   == 0))
+      return morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::DECOD_QUEUE_SCHEME_ONE_FIFO;
+    if ( (x.compare(toString(static_cast<uint32_t>(morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::DECOD_QUEUE_SCHEME_MULTI_FIFO))) == 0) or
+         (x.compare("multi_fifo") == 0))
+      return morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::DECOD_QUEUE_SCHEME_MULTI_FIFO;
+    
+    throw (ErrorMorpheo ("<fromString> : Unknow string : \""+x+"\""));
+  };
+
+
 }; // end namespace morpheo              
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue.cpp	(revision 111)
@@ -76,4 +76,29 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
+        // Function pointer
+        switch (_param->_queue_scheme)
+          {
+          case DECOD_QUEUE_SCHEME_ONE_FIFO :
+            {
+              function_transition         = &morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::function_one_fifo_transition        ;
+              function_genMoore           = &morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::function_one_fifo_genMoore          ;
+              function_genMealy_decod_out = &morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::function_one_fifo_genMealy_decod_out;
+              
+              break;
+            }
+          case DECOD_QUEUE_SCHEME_MULTI_FIFO :
+            {
+              function_transition         = &morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::function_multi_fifo_transition        ;
+              function_genMoore           = &morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::function_multi_fifo_genMoore          ;
+              function_genMealy_decod_out = &morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod_queue::Decod_queue::function_multi_fifo_genMealy_decod_out;
+              
+              break;
+            }
+          default :
+            {
+              break;
+            }
+          }
+
 	log_printf(INFO,Decod_queue,FUNCTION,_("Method - transition"));
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp	(revision 111)
@@ -138,5 +138,9 @@
       {
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-    reg_QUEUE              = new std::list<decod_queue_entry_t*>;
+    switch (_param->_queue_scheme)
+      {
+      case DECOD_QUEUE_SCHEME_ONE_FIFO   : reg_QUEUE = new std::list<decod_queue_entry_t*>; break;
+      case DECOD_QUEUE_SCHEME_MULTI_FIFO : ALLOC1(reg_QUEUE,std::list<decod_queue_entry_t*>,_param->_nb_bank); break;
+      }
     reg_NB_INST            = new uint32_t   [_param->_nb_context];
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp	(revision 111)
@@ -90,5 +90,9 @@
 
         // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-        delete    reg_QUEUE;
+        switch (_param->_queue_scheme)
+          {
+          case DECOD_QUEUE_SCHEME_ONE_FIFO   : delete reg_QUEUE; break;
+          case DECOD_QUEUE_SCHEME_MULTI_FIFO : DELETE1(reg_QUEUE,_param->_nb_bank); break;
+          } 
         delete [] reg_NB_INST;
         
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMealy_decod_out.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMealy_decod_out.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMealy_decod_out.cpp	(revision 111)
@@ -0,0 +1,120 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace decod_unit {
+namespace decod_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Decod_queue::function_multi_fifo_genMealy_decod_out"
+  void Decod_queue::function_multi_fifo_genMealy_decod_out (void)
+  {
+    log_begin(Decod_queue,FUNCTION);
+    log_function(Decod_queue,FUNCTION,_name.c_str());
+    
+    Tcontrol_t val [_param->_nb_inst_decod];
+    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+      {
+	val                    [i] = 0;
+	internal_DECOD_OUT_VAL [i] = 0;
+	internal_DECOD_OUT_ACK [i] = 0;
+      }
+    
+    uint32_t num_bank = reg_NUM_BANK_HEAD%_param->_nb_bank;
+    
+    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+      {
+        log_printf(TRACE,Decod_queue,FUNCTION,_("  * num_bank : %d"),num_bank);
+
+        if (not reg_QUEUE[num_bank].empty())
+          {
+            log_printf(TRACE,Decod_queue,FUNCTION,_("  * Queue is not empty, slot [%d] is valid."),i);
+            
+            Tcontext_t context         = reg_QUEUE[num_bank].front()->_context_id    [0];
+            Tdepth_t   depth           = reg_QUEUE[num_bank].front()->_depth         [0];
+            Tdepth_t   depth_min       = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MIN [context]):0;
+            Tdepth_t   depth_max       = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MAX [context]):0;
+            Tcontrol_t depth_full      = PORT_READ(in_DEPTH_FULL[context]);
+
+            // is a valid instruction ?
+            // If DEPTH_CURRENT :
+            // equal at     DEPTH_MIN            -> not speculative
+            // not include ]DEPTH_MIN:DEPTH_MAX] -> previous branch miss
+            //     include ]DEPTH_MIN:DEPTH_MAX] -> speculative
+            
+            // All case
+            // ....... min ...X... max ....... OK
+            // ....... min ....... max ...X... KO
+            // ...X... min ....... max ....... KO
+            // ....... max ....... min ...X... OK
+            // ...X... max ....... min ....... OK
+            // ....... max ...X... min ....... KO
+            
+            Tcontrol_t   is_valid      = ((depth == depth_min) or
+                                          depth_full or
+                                          ((depth_min <= depth_max)?
+                                           ((depth >= depth_min) and (depth <=depth_max)):
+                                           ((depth >= depth_min) or  (depth <=depth_max))));
+            //Tcontrol_t is_valid        = ((depth == depth_min) or 
+            //                              ((depth_min < depth_max)?
+            //                               (depth<=depth_max):
+            //                               ((depth > depth_min) or (depth <= depth_max))));
+            //Tcontrol_t is_valid        = depth <= depth_max;
+            
+            log_printf(TRACE,Decod_queue,FUNCTION,"    * is_valid : %d",is_valid);
+            log_printf(TRACE,Decod_queue,FUNCTION,"      * context      : %d",context);
+            log_printf(TRACE,Decod_queue,FUNCTION,"      * depth        : %d",depth);
+            log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_min    : %d",depth_min);
+            log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_max    : %d",depth_max);
+            log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_full   : %d",depth_full);
+#ifdef DEBUG
+            log_printf(TRACE,Decod_queue,FUNCTION,"      * address      : 0x%x (0x%x)",reg_QUEUE[num_bank].front()->_address     [0],reg_QUEUE[num_bank].front()->_address     [0]<<2);
+#endif
+            log_printf(TRACE,Decod_queue,FUNCTION,"      * address_next : 0x%x (0x%x)",reg_QUEUE[num_bank].front()->_address_next[0],reg_QUEUE[num_bank].front()->_address_next[0]<<2);
+
+            internal_DECOD_OUT_VAL [i] = 1; // in all case, val is set (entry is not empty, and instruction is valid)
+            if (is_valid)
+              {
+                val                    [i] = 1;
+                internal_DECOD_OUT_ACK [i] = PORT_READ(in_DECOD_OUT_ACK [i]);
+              }
+            else
+              {
+                // Consume the instruction (to erase)
+                internal_DECOD_OUT_ACK [i] = 1;
+              }
+          }
+        num_bank = (num_bank+1)%_param->_nb_bank;
+      }
+    
+    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+      {
+        log_printf(TRACE,Decod_queue,FUNCTION,"  * DECOD_OUT_VAL : %d",val [i]);
+        
+        PORT_WRITE(out_DECOD_OUT_VAL [i],val [i]);
+      }
+
+    log_end(Decod_queue,FUNCTION);
+  };
+
+}; // end namespace decod_queue
+}; // end namespace decod_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMoore.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_function_multi_fifo_genMoore.cpp	(revision 111)
@@ -0,0 +1,100 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace decod_unit {
+namespace decod_queue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Decod_queue::function_multi_fifo_genMoore"
+  void Decod_queue::function_multi_fifo_genMoore (void)
+  {
+    log_begin(Decod_queue,FUNCTION);
+    log_function(Decod_queue,FUNCTION,_name.c_str());
+
+    //--------------------------------------------------------------------
+    //-----[ DECOD_IN ]---------------------------------------------------
+    //--------------------------------------------------------------------
+    {
+      uint32_t num_bank = reg_NUM_BANK_TAIL;
+
+      for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+        {
+	  internal_DECOD_IN_ACK [i] = (reg_QUEUE[num_bank].size() < _param->_size_queue);
+	  PORT_WRITE(out_DECOD_IN_ACK [i],internal_DECOD_IN_ACK [i]);
+
+          num_bank = (num_bank+1)%_param->_nb_bank;
+	}
+    }
+
+    //--------------------------------------------------------------------
+    //-----[ DECOD_OUT ]--------------------------------------------------
+    //--------------------------------------------------------------------
+    {
+      uint32_t num_bank = reg_NUM_BANK_HEAD%_param->_nb_bank;
+
+        for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+          {
+            if (not reg_QUEUE[num_bank].empty())
+              {
+                if (_param->_have_port_context_id)
+	        PORT_WRITE(out_DECOD_OUT_CONTEXT_ID    [i],reg_QUEUE[num_bank].front()->_context_id    [0]);
+	        if (_param->_have_port_depth)
+	        PORT_WRITE(out_DECOD_OUT_DEPTH         [i],reg_QUEUE[num_bank].front()->_depth         [0]);
+	        PORT_WRITE(out_DECOD_OUT_TYPE          [i],reg_QUEUE[num_bank].front()->_type          [0]);
+	        PORT_WRITE(out_DECOD_OUT_OPERATION     [i],reg_QUEUE[num_bank].front()->_operation     [0]);
+	        PORT_WRITE(out_DECOD_OUT_NO_EXECUTE    [i],reg_QUEUE[num_bank].front()->_no_execute    [0]);
+	        PORT_WRITE(out_DECOD_OUT_IS_DELAY_SLOT [i],reg_QUEUE[num_bank].front()->_is_delay_slot [0]);
+#ifdef DEBUG
+                PORT_WRITE(out_DECOD_OUT_ADDRESS       [i],reg_QUEUE[num_bank].front()->_address       [0]);
+#endif
+	        PORT_WRITE(out_DECOD_OUT_ADDRESS_NEXT  [i],reg_QUEUE[num_bank].front()->_address_next  [0]);
+	        PORT_WRITE(out_DECOD_OUT_HAS_IMMEDIAT  [i],reg_QUEUE[num_bank].front()->_has_immediat  [0]);
+	        PORT_WRITE(out_DECOD_OUT_IMMEDIAT      [i],reg_QUEUE[num_bank].front()->_immediat      [0]);
+	        PORT_WRITE(out_DECOD_OUT_READ_RA       [i],reg_QUEUE[num_bank].front()->_read_ra       [0]);
+	        PORT_WRITE(out_DECOD_OUT_NUM_REG_RA    [i],reg_QUEUE[num_bank].front()->_num_reg_ra    [0]);
+	        PORT_WRITE(out_DECOD_OUT_READ_RB       [i],reg_QUEUE[num_bank].front()->_read_rb       [0]);
+	        PORT_WRITE(out_DECOD_OUT_NUM_REG_RB    [i],reg_QUEUE[num_bank].front()->_num_reg_rb    [0]);
+	        PORT_WRITE(out_DECOD_OUT_READ_RC       [i],reg_QUEUE[num_bank].front()->_read_rc       [0]);
+	        PORT_WRITE(out_DECOD_OUT_NUM_REG_RC    [i],reg_QUEUE[num_bank].front()->_num_reg_rc    [0]);
+	        PORT_WRITE(out_DECOD_OUT_WRITE_RD      [i],reg_QUEUE[num_bank].front()->_write_rd      [0]);
+	        PORT_WRITE(out_DECOD_OUT_NUM_REG_RD    [i],reg_QUEUE[num_bank].front()->_num_reg_rd    [0]);
+	        PORT_WRITE(out_DECOD_OUT_WRITE_RE      [i],reg_QUEUE[num_bank].front()->_write_re      [0]);
+	        PORT_WRITE(out_DECOD_OUT_NUM_REG_RE    [i],reg_QUEUE[num_bank].front()->_num_reg_re    [0]);
+	        PORT_WRITE(out_DECOD_OUT_EXCEPTION_USE [i],reg_QUEUE[num_bank].front()->_exception_use [0]);
+	        PORT_WRITE(out_DECOD_OUT_EXCEPTION     [i],reg_QUEUE[num_bank].front()->_exception     [0]);
+              }
+            num_bank = (num_bank+1)%_param->_nb_bank;
+          }
+    }
+
+    //--------------------------------------------------------------------
+    //-----[ NB_INST ]----------------------------------------------------
+    //--------------------------------------------------------------------
+    for (uint32_t i=0; i<_param->_nb_context; i++)
+      PORT_WRITE(out_NB_INST_ALL [i], reg_NB_INST [i]);
+
+    log_end(Decod_queue,FUNCTION);
+  };
+
+}; // end namespace decod_queue
+}; // end namespace decod_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
